import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.PriorityQueue;

/**
 * Die Klasse Knoten repraesentiert Knoten in einem Graphen.
 * Sie stellt auch Methoden zur Verwaltung aller Knoten bereit.
 * 
 * @author (claus albowski) 
 * @version (dez 06)
 */
public class Knoten extends Point2D.Double
{
    // Klassenvariable
    private static ArrayList<Knoten> knotenListe = new ArrayList<Knoten>();
    private static int x=300;
    private static int y=300;
    // Klassenmethode
    private static void neuerKnoten(Knoten k){ knotenListe.add(k); }
    public static void setzeDimension(int breite, int hoehe){ x=breite;y=hoehe; }
    public static Knoten gibKnoten(int i){ return knotenListe.get(i); }
    // Instanzvariable
    private PriorityQueue<Kante> kantenListe;
    
    /**
     * Konstruktor fuer zufaellig erzeugte Objekte der Klasse Knoten.
     */
    public Knoten() {
        super(x*Math.random(), y*Math.random());
        neuerKnoten(this);
        kantenListe = new PriorityQueue<Kante>();
    }
    
    /**
     * Konstruktor fuer Objekte der Klasse Knoten mit vorgegebenen Werten.
     */
    public Knoten(double xPos, double yPos) {
        super(xPos, yPos);
        neuerKnoten(this);
        kantenListe = new PriorityQueue<Kante>();
    }
    
    /**
     * nimmt eine neue Kante auf.
     */
    public void neueKante(Kante k){
        kantenListe.add(k);
    }
    
    /**
     * entfernt eine vorhandene Kante.
     */
    public void entferneKante(Kante k){
        kantenListe.remove(k);
    }
    
    /**
     * gibt die von diesem Knoten ausgehenden Kanten sortiert zurueck.
     */
    public PriorityQueue<Kante> gibSortierteKanten(){
        return kantenListe;
    }
}
